$!	EDITLIB.COM - A procedure for libraries
$SAY:=WRITE SYS$OUTPUT
$INTERACTIVE:="YES"
$LIBNAME:='P2'
$LFILE:='P3'
$IF P1 .NES. "" THEN INTERACTIVE:="NO"
$IF P1 .NES. "" THEN GOTO ENTER_OK
$HELP:
$TYPE SYS$INPUT

 EDITLIB is a procedure for updating and maintaining libraries:
	      Options: N - Create new library
	               E - Extract from library
	               R - Replace/add to library
	               L - List names on library
	               D - Delete names from library
	               C - Compress library
	               H - Displays option list
	               S - Stop procedure
	               X - Define different library name
$ENTER:
$IF "''INTERACTIVE'" .EQS. "NO" THEN GOTO STOP
$INQUIRE P1 "Enter option?"
$ENTER_OK:
$IF P1 .EQS. "H" THEN GOTO HELP
$IF P1 .EQS. "S" THEN GOTO STOP
$IF P1 .EQS. "N" THEN GOTO NOP2
$IF P1 .EQS. "X" THEN GOTO NOP2
$IF P1 .EQS. "E" .OR. P1 .EQS. "R" .OR. P1 .EQS. "L" -
              	 .OR. P1 .EQS. "C" .OR. P1 .EQS. "D" THEN GOTO LIB_CHK
$LP1='F$LENGTH(P1)-2
$IF "''F$EXTRACT(0,1,P1)'" .EQS. "L" THEN LFILE:='F$EXTRACT(2,LP1,P1)
$IF "''F$EXTRACT(0,1,P1)'" .EQS. "L" THEN P1:="L"
$IF P1 .EQS. "L" THEN GOTO LIB_CHK
$IF "''F$EXTRACT(0,1,P1)'" .EQS. "X" THEN LIBNAME:='F$EXTRACT(2,LP1,P1)
$IF "''F$EXTRACT(0,1,P1)'" .EQS. "X" THEN P1:="X"
$IF P1 .EQS. "X" THEN GOTO LIB_CHK
$GOTO HELP
$LIB_CHK:
$IF "''LIBNAME'" .EQS. "" THEN LIBEXT:=""
$IF "''LIBNAME'" .EQS. "" THEN INQUIRE LIBNAME "What is library name?"
$!	FIND FILE EXTENSION TYPE; RETURNED AS SYMBOL EXTYPE
$@DBA1:[EJB.SYSTEM]FINDEXT 'LIBNAME'
$!
$LIBEXT:='EXTYPE'
$EXT:=""
$IF "''LIBEXT'" .EQS. "TLB" .OR. "''LIBEXT'" .EQS. "OLB" .OR.-
    "''LIBEXT'" .EQS. "HLB" .OR. "''LIBEXT'" .EQS. "FLB" .OR.-
    "''LIBEXT'" .EQS. "MLB" THEN GOTO LIB_OPEN
$INQUIRE LIBEXT "What type is library (F[ORTRAN] , T[EXT] , O[BJECT]" -
    " , H[ELP] or M[ACRO])?"
$LIBT:='F$EXTRACT(0,1,LIBEXT)
$IF "''LIBT'" .EQS. "T" THEN LIBEXT:="TLB"
$IF "''LIBT'" .EQS. "O" THEN LIBEXT:="OLB"
$IF "''LIBT'" .EQS. "H" THEN LIBEXT:="HLB"
$IF "''LIBT'" .EQS. "F" THEN LIBEXT:="FLB"
$IF "''LIBT'" .EQS. "M" THEN LIBEXT:="MLB"
$EXT:=".''LIBEXT'"
$LIB_OPEN:
$LIBT:='F$EXTRACT(0,1,LIBEXT)
$IF "''LIBT'" .EQS. "F" THEN LIBTYPE:="/TEXT"
$IF "''LIBT'" .EQS. "T" THEN LIBTYPE:="/TEXT"
$IF "''LIBT'" .EQS. "O" THEN LIBTYPE:="/OBJECT"
$IF "''LIBT'" .EQS. "H" THEN LIBTYPE:="/HELP"
$IF "''LIBT'" .EQS. "M" THEN LIBTYPE:="/MACRO"
$IF "''LIBT'" .EQS. "F" THEN DEFEXT:=".FOR"
$IF "''LIBT'" .EQS. "T" THEN DEFEXT:=".TXT"
$IF "''LIBT'" .EQS. "O" THEN DEFEXT:=".OBJ"
$IF "''LIBT'" .EQS. "H" THEN DEFEXT:=".HLP"
$IF "''LIBT'" .EQS. "M" THEN DEFEXT:=".MAR"
$LIBNAME:='LIBNAME''EXT'
$IF P1 .EQS. "N" THEN GOTO CREATE
$OPEN/ERROR=NOLIB LIB 'LIBNAME'
$CLOSE LIB
$IF P1 .EQS. "L" THEN GOTO LIST
$IF P1 .EQS. "R" THEN GOTO REPLACE
$IF P1 .EQS. "E" THEN GOTO EXTRACT
$IF P1 .EQS. "C" THEN GOTO COMPRESS
$IF P1 .EQS. "D" THEN GOTO DELETE
$GOTO HELP
$NOLIB:
$SAY "Library called ''LIBNAME' is not available!"
$LIBNAME:=""
$GOTO ENTER
$NO_FILE:
$SAY "File specified (''P3') for previous option does not exist or wrong type."
$P3:=""
$GOTO ENTER
$NOP2:
$LIBNAME:=""
$GOTO LIB_CHK
$LIST:
$IF "''LFILE'" .EQS. "" THEN LFILE:='F$LOGICAL("TT")
$ALL:=""
$IF "''LIBT'" .EQS. "O" THEN ALL:="/NAME/WIDTH=10"
$LIBRARY/LIST=LIBRARY.LIS'LIBTYPE''ALL' 'LIBNAME'
$ASSIGN/USER 'LFILE' SYS$OUTPUT
$RUN DBA1:[EJB.SYSTEM]LIBLIST.EXE
$IF "''LFILE'" .NES. "''F$LOGICAL("TT")'" THEN -
	SAY "List of modules on library ''libname' written to ''LFILE'"
$IF "''LFILE'" .EQS. "PRINTER" THEN PRINT/DELETE PRINTER.DAT
$DELETE LIBRARY.LIS;
$LFILE:=""
$GOTO ENTER
$CREATE:
$IF P3 .EQS. "" THEN -
	INQUIRE P3 "What is file name to use to build your library?"
$@DBA1:[EJB.SYSTEM]FINDEXT 'P3'
$FEXT:=""
$IF "''EXTYPE'" .EQS. "" THEN FEXT:='DEFEXT'
$IF "''LIBT'" .NES. "F" THEN GOTO CREATE_OTHER
$OPEN/READ/ERR=NO_FILE TESTOPEN 'P3''FEXT'
$CLOSE TESTOPEN
$ASSIGN/USER 'P3''FEXT' FOR001
$RUN DBA1:[EJB.SYSTEM]SEPTXT.EXE
$LIBRARY/CREATE'LIBTYPE' 'LIBNAME' *.RTX
$DELETE *.RTX.*
$GOTO CREATE_END
$CREATE_OTHER:
$OPEN/READ/ERR=NO_FILE TESTOPEN 'P3''FEXT'
$CLOSE TESTOPEN
$LIBRARY/CREATE'LIBTYPE' 'LIBNAME' 'P3'
$CREATE_END:
$SAY "Library ''LIBNAME' created using file> ''P3' !"
$P3:=""
$GOTO ENTER
$COMPRESS:
$IF P3 .EQS. "" THEN -
	INQUIRE P3 "Enter new library name (if same as current enter <CR>)?"
$IF P3 .EQS. "" THEN P3:='LIBNAME'
$LIBRARY/COMPRESS/OUTPUT='P3''LIBTYPE' 'LIBNAME' 
$SAY "Library ''LIBNAME' has been compressed and new file ''P3' created!"
$P3:=""
$GOTO ENTER
$REPLACE:
$IF P3 .EQS. "" THEN -
	INQUIRE P3 "What is file name containing replacement info?"
$@DBA1:[EJB.SYSTEM]FINDEXT 'P3'
$FEXT:=""
$IF "''EXTYPE'" .EQS. "" THEN FEXT:='DEFEXT'
$IF "''LIBT'" .NES. "F" THEN GOTO REPLACE_OTHER
$OPEN/READ/ERR=NO_FILE TESTOPEN 'P3''FEXT'
$CLOSE TESTOPEN
$ASSIGN/USER 'P3''FEXT' FOR001
$RUN DBA1:[EJB.SYSTEM]SEPTXT.EXE
$LIBRARY/REPLACE'LIBTYPE 'LIBNAME' *.RTX
$DELETE *.RTX.*
$GOTO REPLACE_END
$REPLACE_OTHER:
$OPEN/READ/ERR=NO_FILE TESTOPEN 'P3''FEXT'
$CLOSE TESTOPEN
$LIBRARY/REPLACE'LIBTYPE' 'LIBNAME' 'P3'
$REPLACE_END:
$P3:=""
$GOTO ENTER
$EXTRACT:
$IF P3 .EQS. "" THEN -
	INQUIRE P3 "What is file name to receive extracted info?"
$IF P4 .EQS. "" THEN -
	INQUIRE P4 "Which names do you wish to extract?"
$@DBA1:[EJB.SYSTEM]FINDEXT 'P3'
$FEXT:=""
$IF "''EXTYPE'" .EQS. "" THEN FEXT:='DEFEXT'
$IF P4 .EQS. "" .AND. "''EXTYPE'" .EQS. "" THEN P4:='P3'
$LIBRARY/EXTRACT=('P4')/OUTPUT='P3''FEXT''LIBTYPE' 'LIBNAME'
$P4:=""
$P3:=""
$GOTO ENTER
$DELETE:
$IF P3 .EQS. "" THEN -
	INQUIRE P3 "What names do you wish to delete?"
$LIBRARY/DELETE=('P3')'LIBTYPE' 'LIBNAME'
$P3:=""
$GOTO ENTER
$STOP:
$EXIT
