C	ACCOUNTING PROGRAM OBTAINED FROM VAX COURSE JUNE 1978.
C	MODIFIED FOR USE WITH RELEASE 1.0 BY J. THOMPSON INTERMETRICS.
C	ADDED "FORGET USER FEATURE" NOVEMBER 9, 1978.
C1	MODIFIED 10-APR-1980 FOR USE AT KCL TO EXPAND THE STORAGE
C1	SINCE THERE ARE MORE THAN 100 USERS.
C2	MODIFIED 4-AUG-1980 to print out useful statistics for
C2	system reports.
C
	IMPLICIT INTEGER (A-Z)
	PARAMETER MAX_USERS = 1000
	PARAMETER MAX_USER_PARMS = 10
	PARAMETER MAX_ACCT = 50
	PARAMETER MAX_ACCT_PARMS = 10
	INTEGER*2 MSGTYPE,MSGSIZE,INTER_JOB_TYPE,BATCH_JOB_TYPE
	INTEGER*2 PRINT_JOB_TYPE,LOGIN_FAILURE
	CHARACTER*24 TIMBUF1,TIMBUF2,LOWTIME,HITIME
	CHARACTER*256 MSGBUF
	CHARACTER FLAG*1
	CHARACTER*30 INFILE,OUTFILE
	CHARACTER USERNAME(MAX_USERS)*12,CUR_USER*12
	CHARACTER ACCOUNTS(MAX_ACCT)*8,CUR_ACCT*8
	CHARACTER FORGETUSER(20)*12
	INTEGER*2 NUMBERFORGOT,NUMBERACCT
	REAL MONTHTIME,MONTHHRS
	REAL MONTHDAYS
	REAL CPU_SEC
	INTEGER ACCT_INDEX(MAX_ACCT)
	DIMENSION ELAPSED(2),TERMTIME(2),LOGIN(2)
	DIMENSION JOB_NAME(2),JOB_QUE(4)
	DIMENSION QUETIME(2),PRT_NAME(2),PRT_QUE(3)
	DIMENSION REST(16)
	DIMENSION ICOUNTS(MAX_USERS,MAX_USER_PARMS)
C		ICOUNTS ARRAY ELEMENTS (USER PARAMETERS)
C		1 - CPU TIME IN 10 MS UNITS
C		2 - # OF PAGE FAULTS
C		3 - # LOGINS (BATCH+INTERACTIVE)
C		4 - # ELAPSED SECS (INTERACTIVE JOBS)
C		5 - # BUFFERED I/O S
C		6 - # DIRECT I/O S
C		7 - # VOLUME MOUNTS
C		8 - # PRINT JOBS
C		9 - # PAGES PRINTED
C		10 - ACCOUNT INDEX
	INTEGER ACCT_DATA(MAX_ACCT_PARMS,0:MAX_ACCT)
C		ACCT_DATA ARRAY ELEMENTS (ACCOUNT PARAMETERS)
C		1 - ACCOUNT NUMBER
C		2 - NUMBER OF USERS
C		3 - NUMBER OF LOGINS
C		4 - ELAPSED SECONDS
C		5 - BUFFERED I/O
C		6 - DIRECT I/O
C		7 - VOLUME MOUNTS
C		8 - PRINT JOBS
C		9 - PAGES PRINTED
C		10 - CONNECT TIME
	COMMON FIRST_TIME(2),LAST_TIME(2),FILE_TYPE,DATAOUT,LOW_TIME(2),
	2	HI_TIME(2)
C
C BASIC RECORD FIELDS
C	MSGTYPE,MSGSIZE,FINALSTS,PID,JOBID,TERMTIME,CUR_ACCT,CUR_USER
C
C INTERACTIVE/BATCH JOB FIELDS
C
	EQUIVALENCE (CPUTIM,REST(1)),(PAGEFLTS,REST(2)),(PGFLPEAK,REST(3))
	EQUIVALENCE (WSPEAK,REST(4)),(BIOCNT,REST(5)),(DIOCNT,REST(6))
	EQUIVALENCE (VOLUMES,REST(7)),(LOGIN(1),REST(8))
	EQUIVALENCE (LOGIN(2),REST(9)),(OWNER,REST(10))
C
C BATCH JOB FIELDS
C
	EQUIVALENCE (JOB_NAME(1),REST(11)),(JOB_NAME(2),REST(12))
	EQUIVALENCE (JOB_QUE(1),REST(13)),(JOB_QUE(2),REST(14))
	EQUIVALENCE (JOB_QUE(3),REST(15)),(JOB_QUE(4),REST(16))
C
C PRINT JOB FIELDS
C
	EQUIVALENCE (UNKNOWN,REST(1))
	EQUIVALENCE (PAGCNT,REST(2)),(QIOCNT,REST(3)),(GETCNT,REST(4))
	EQUIVALENCE (QUETIME(1),REST(5)),(QUETIME(2),REST(6))
	EQUIVALENCE (PRT_NAME(1),REST(7)),(PRT_NAME(2),REST(8))
	EQUIVALENCE (PRT_QUE(1),REST(9)),(PRT_QUE(2),REST(10))
	EQUIVALENCE (PRT_QUE(3),REST(11))
C
	DATA INTER_JOB_TYPE/3/,BATCH_JOB_TYPE/2/,LOGIN_FAILURE/4/
	DATA PRINT_JOB_TYPE/16/
	DATA INTERMAX/0/,PRINTMAX/0/,LOGIN_FAIL_CNT/0/
	DATA TOTAL_RECORDS/0/
	DATA NUMBERACCT/0/
C
C SET UP COMMON VARIABLES
C
	DATAOUT=1
	DATAIN=2
	FIRST_TIME(1)=0
	FIRST_TIME(2)='7FFFFFFF'X
	LAST_TIME(1)=0
	LAST_TIME(2)=0
C
C GET THE TYPE OF REPORT
C
	TYPE 10
10	FORMAT(' LISTING OR TOTALS [L/T]')
	ACCEPT 20,REP_TYPE
20	FORMAT(A1)
C
C	GET USER NAMES THAT SHOULD BE LEFT OUT OF ACCOUNTING
C
	TYPE *, 'ENTER USERNAMES WHICH SHOULD BE "FORGOTTEN"'
	TYPE *, 'FOR NONE OR NO MORE TYPE RETURN.  (MAX 20 NAMES)'
	I=0
23	ACCEPT 25, CUR_USER
25	FORMAT (A12)
	IF(CUR_USER .EQ. '            ') GO TO 29
	I=I+1
	IF(I .GT. 20) GO TO 29
	FORGETUSER(I)=CUR_USER
	GO TO 23
29	NUMBERFORGOT=I
C
C GET THE OUTPUT DEVICE
C
	TYPE 30
30	FORMAT(' FILE OR TERMINAL [F/T]')
	ACCEPT 40,FILE_TYPE
40	FORMAT(A1)
C
C OPEN THE OUTPUT FILE
C
	IF(FILE_TYPE.EQ.'F')
	1  OPEN(UNIT=DATAOUT,NAME='ACC.DAT',STATUS='NEW'
	2  ,INITIALSIZE=1,EXTENDSIZE=1)
	IF(FILE_TYPE.EQ.'T')
	1  OPEN(UNIT=DATAOUT,NAME='SYS$OUTPUT:',STATUS='NEW',
	2  INITIALSIZE=1,EXTENDSIZE=1)
C
C OPEN THE INPUT FILE
C
	INFILE = ' '
	WRITE(6,*) ' ENTER INPUT FILE_NAME (<CR>=DR0:[SYSMGR]ACCOUNTNG.OLD)'
	READ(5,1000) INFILE
1000	FORMAT(A)
	IF (INFILE .EQ. ' ') INFILE = 'DR0:[SYSMGR]ACCOUNTNG.OLD'
	OPEN(UNIT=DATAIN,NAME=INFILE,TYPE='OLD',READONLY)
	HITIME = ' '
	LOWTIME = ' '
50	WRITE(6,*)' ENTER BEGINNING DATE AS "DD-MMM-YYYY HH:MM:SS.CC" '
	WRITE(6,52)
52	FORMAT(' FIELDS MAY BE OMITTED BUT PUNCTUATION MAY NOT'/,
	2	' BLANK LINE INPUT = 1-JAN-1978 0:0:0.0')

	READ(5,1000) LOWTIME
	IF (LOWTIME .EQ. ' ') LOWTIME = '1-JAN-1978 0:0:0.0'
	IF(.NOT.SYS$BINTIM(LOWTIME,LOW_TIME)) THEN
		WRITE(6,*) ' INVALID TIME FORMAT'
		GO TO 50
		ENDIF
C	PUT IN CANONICAL FORM
	CALL CVT_TIME(LOWTIME,LEN1,LOW_TIME)
60	WRITE(6,*)' ENTER ENDING DATE '
	WRITE(6,62)
62	FORMAT (' BLANK LINE INPUT = 31-DEC-1999 23:59:59.99')
	READ(5,1000) HITIME
	IF (HITIME .EQ. ' ') HITIME = '31-DEC-1999 23:59:59.99'
	IF (.NOT. SYS$BINTIM(HITIME,HI_TIME)) THEN
		WRITE(6,*) ' INVALID TIME FORMAT'
		GO TO 60
		ENDIF
C	PUT IN CANONICAL FORM
	CALL CVT_TIME(HITIME,LEN1,HI_TIME)
C***************************************************************
C
C READ THE RECORD
C
100	READ(DATAIN,110,ERR=9950,END=9000) MSGTYPE,MSGSIZE,FINALSTS,PID,
	1JOBID,TERMTIME,CUR_ACCT,CUR_USER,REST
110	FORMAT(2A2,5A4,A8,A12,16A4)
C
C	MAYBE SKIP THIS RECORD
C
	IF(NUMBERFORGOT .EQ. 0) GO TO 113
	DO 112 I = 1, NUMBERFORGOT
	IF(CUR_USER .EQ. FORGETUSER(I)) GO TO 100 !SKIP THIS RECORD
112	CONTINUE
C
C ADD 1 FOR THIS RECORD
C
113	TOTAL_RECORDS=TOTAL_RECORDS+1
C
C VALIDATE AND DISPATCH TO CORRECT REPORT
C
	FLAG = ' '
	IF (MSGTYPE .EQ. 1) FLAG = 'I'	!USE INTERACTIVE TYPE HERE
	IF (MSGTYPE .EQ. 3) FLAG = 'I'	!INTERACTIVE JOB
	IF (MSGTYPE .EQ. 2) FLAG = 'B'	!BATCH JOB
	IF (MSGTYPE .EQ.16) FLAG = 'P'	!PRINT JOB
	IF (FLAG .EQ. ' ') GO TO 115	!BAD RECORD
C
C UPDATE TIME SPAN OF THIS FILE
C
	IF (.NOT. CHECK_TIME(TERMTIME)) GO TO 100 !CHECK END TIME
	IF ((FLAG .EQ. 'I') .OR. (FLAG .EQ. 'B')) THEN
C		CHECK START TIME
		IF(.NOT.CHECK_TIME(LOGIN)) GO TO 100
C
C 		CALC CPU TIME IS SECONDS
C
		CPU_SEC=FLOAT(CPUTIM)/100.
		CALL SUBQUAD(TERMTIME,LOGIN,ELAPSED)
		CALL EDIV(ELAPSED,10000000,IELAPSE)
		IF(IELAPSE.GT.24*60*60*10) GOTO 100  !No-one's on 10 days
		IF(MSGTYPE .EQ. 1) IELAPSE = 0	!USE 0 FOR NON-INT
		ENDIF
C
C	CHECK START TIME OF PRINT JOB
	IF(FLAG .EQ. 'P') THEN
		IF(.NOT.CHECK_TIME(QUETIME)) GO TO 100
		ENDIF
	IF (REP_TYPE .EQ. 'T') GO TO 500	!TOTALS REPORT
	IF (REP_TYPE .EQ. 'L') GO TO 140	!FULL LISTING
C********************************************************************
C	BAD RECORD
C CHECK IF IT IS A LOGIN FAILURE MESSAGE
C
115	IF(MSGTYPE.NE.LOGIN_FAILURE) GO TO 120
	LOGIN_FAIL_CNT=LOGIN_FAIL_CNT+1
	GO TO 100
C
C UNEXPECTED MSG TYPE
C
120	TYPE 130, MSGTYPE,MSGSIZE,CUR_USER
130	FORMAT('0UNRECOGNIZED TYPE'/' MSGTYPE = ',Z4,' MSGSIZE = ',
	1Z4,' USERNAME = ',A12)
	IF(FILE_TYPE.EQ.'F') WRITE(DATAOUT,130)MSGTYPE,MSGSIZE,CUR_USER
	GO TO 100
C
C*****************************************************************
C LIST THE ACCOUNT INFORMATION
C***********
C
140	CALL CVT_TIME(TIMBUF1,LEN1,LOGIN)
C
C
C	TEST FOR PAGE HEADER
C
	IF (MOD(LINES,50) .EQ. 0) 
	2  	WRITE(DATAOUT,2000)INFILE,LOWTIME,HITIME
2000	FORMAT('1',' LISTING OF FILE: ',A,' FOR THE PERIOD ',A,' TO ',A,//
	2	'  USERNAME     TYPE      START-TIME        ELAPSED-SECS CPU-SECS',
	2	'  PG-FAULTS BUF I/O   DIR I/O VOL-MOUNTS JOB-NAME',
	2	' PG-COUNT      QIOS')
	LINES = LINES + 1
C
C TYPE 1,3 (NON-INTERACTIVE & INTERACTIVE)
C
	IF (FLAG .EQ. 'I') THEN
		WRITE(DATAOUT,2100) CUR_USER,FLAG,TIMBUF1,IELAPSE,CPU_SEC,
	2	PAGEFLTS,BIOCNT,DIOCNT,VOLUMES
2100		FORMAT(' ',A13,A3,' ',A20,I12,F11.2,4I10)
		GO TO 500
		ENDIF
C
C TYPE 2 (BATCH)
C
C
C
	IF (FLAG .EQ. 'B') THEN
		WRITE(DATAOUT,2150) CUR_USER,FLAG,TIMBUF1,IELAPSE,CPU_SEC,
	2	BIOCNT,DIOCNT,VOLUMES,JOB_NAME
2150		FORMAT (' 'A13,A3,' ',A20,I12,F11.2,10X,3I10,'   ',2A4)
		GO TO 500
		ENDIF

C
C TYPE 16 (PRINT)
C
	IF (FLAG .EQ. 'P') THEN 
C 		CONVERT QUE TIME TO ASCII
C
		CALL CVT_TIME(TIMBUF1,LEN1,QUETIME)
C
C 		WRITE OUT THE DATA
C
		WRITE(DATAOUT,2200) CUR_USER,FLAG,TIMBUF1,
	2	PRT_NAME,PAGCNT,QIOCNT
2200		FORMAT(' ',A13,A3,' ',A20,T105,2A4,T114,2I9)
		GO TO 500
		ENDIF
C********************************************************************
C
C**********
C TOTALS
C**********
C
C 	LOOK FOR THE USERNAME
C
500	DO 510 I=1,INTERMAX+1
	INDX=I
	IF (CUR_USER .EQ. USERNAME(I)) GO TO 540
	IF (CUR_USER .LT. USERNAME(I)) GO TO 515
510	CONTINUE
C
C ENTER NEW USER
C
515	INTERMAX = INTERMAX + 1	!NUMBER OF USERS SEEN SO FAR
	IF (INTERMAX .EQ. 1) GO TO 530
	IF (INTERMAX .GT. MAX_USERS) STOP 'TOO MANY USERS-STORAGE EXCEEDED'
C
C	PUSH DOWN CURRENT DATA VALUES
	DO 520 I = INTERMAX,INDX,-1
	USERNAME(I)= USERNAME(I-1)
	DO 520 J = 1,MAX_USER_PARMS
520	ICOUNTS(I,J) = ICOUNTS(I-1,J)
C
C	NOW CLEAR THE ARRAY ELEMENTS FOR NEW USER
530	DO 535 J = 1,MAX_USER_PARMS
535	ICOUNTS(INDX,J) = 0
C
	USERNAME(INDX) = CUR_USER
C**************
C  DETERMINE THE ACCOUNT INDEX IN A SIMILAR FASHION AND ADD 
C  TO ICOUNTS(INDX,10).
C**************
C
	DO 600 I = 1,NUMBERACCT+1
	INDX2 = I
	IF (ACCOUNTS(I).EQ.CUR_ACCT) GOTO 640
	IF (ACCOUNTS(I).GT.CUR_ACCT) GOTO 610
600	CONTINUE
C
C	ADD NEW ACCOUNT
C
610	CONTINUE
	NUMBERACCT = NUMBERACCT+1
	IF (NUMBERACCT.EQ.1) GOTO 630
	IF (NUMBERACCT.GT.MAX_ACCT) STOP 'TOO MANY ACCOUNTS--STORAGE OVERFLOW'
C
C	PUSH DOWN CURRENT ACCOUNTS TO MAKE ROOM FOR
C	THE NEW ACCOUNT NAME. (INSERTION SORT)
C
	DO 620 I = NUMBERACCT,INDX2,-1
	ACCOUNTS(I) = ACCOUNTS(I-1)
	DO 620 J = 1,MAX_ACCT_PARMS
	ACCT_DATA(J,I) = ACCT_DATA(J,I-1)
620	CONTINUE
C
C
C	ADJUST CURRENT ACCOUNT INDICIES
C
	DO 625 I = 1,NUMBERACCT-1
	IF (ACCT_INDEX(I).GE.INDX2) ACCT_INDEX(I) = ACCT_INDEX(I)+1
625	CONTINUE
C
C	ADD ACCOUNT INTO PROPER SLOT
C
630	CONTINUE
	ACCOUNTS(INDX2) = CUR_ACCT
	ACCT_DATA(1,INDX2) = NUMBERACCT
	ACCT_DATA(2,INDX2) = 0
	ACCT_INDEX(NUMBERACCT) = INDX2
C
C	FINALLY, UPDATE THE USER DATA
C
640	CONTINUE
	ICOUNTS(INDX,10) = ACCT_DATA(1,INDX2)
	ACCT_DATA(2,INDX2) = ACCT_DATA(2,INDX2)+1
C
C**************
C UPDATE NON-INTERACTIVE, INTERACTIVE & BATCH TOTALS
C***************
540	IF (FLAG .EQ. 'P') GO TO 550	!PRINT RECORD
C
C	UPDATE BATCH/INTERACTIVE TOTALS
	ICOUNTS(INDX,1)=ICOUNTS(INDX,1)+CPUTIM
	ICOUNTS(INDX,2)=ICOUNTS(INDX,2)+PAGEFLTS
	ICOUNTS(INDX,3) = ICOUNTS(INDX,3) + 1	!LOGIN COUNT
	ICOUNTS(INDX,4)=ICOUNTS(INDX,4) + IELAPSE
	ICOUNTS(INDX,5)=ICOUNTS(INDX,5)+BIOCNT
	ICOUNTS(INDX,6)=ICOUNTS(INDX,6)+DIOCNT
	ICOUNTS(INDX,7)=ICOUNTS(INDX,7)+VOLUMES
	GO TO 100
C****************
C
C  UPDATE PRINT JOB TOTALS
C
C****************
550	ICOUNTS(INDX,8)=ICOUNTS(INDX,8) + 1 	!# OF PRINT JOBS
	ICOUNTS(INDX,9)=ICOUNTS(INDX,9) + PAGCNT !# OF PAGES PRINTED
	GO TO 100
C*********************************************************************
C
C END OF FILE READ
C
9000	CONTINUE
	IF (INTERMAX .EQ. 0) THEN
		WRITE(DATAOUT,9020)
9020	FORMAT('1**** NO INTERACTIVE OR BATCH JOBS ****')
		GO TO 9928
		ENDIF
	DO 9500 J = 1,NUMBERACCT
	IF (ACCT_DATA(2,J).EQ.0) GOTO 9500
	LINES = 0		! FORCE PAGES BETWEEN ACCOUNTS
	I = 0
	K = ACCT_DATA(2,J)
	L = ACCT_DATA(1,J)
C
C	LOOK FOR A USER UNDER THIS ACCOUNT.  WHEN FOUND,
C	PROCESS IT.
C
9050	CONTINUE
	I = I+1
	IF (I.EQ.INTERMAX) GOTO 9500
	IF (ICOUNTS(I,10).NE.L) GOTO 9050
C
	CPU_SEC=FLOAT(ICOUNTS(I,1))/100.
	CALL SECS_CVT(ICOUNTS(I,4),HRS,MINS,SECS)
C
C	WRITE OUT THE PAGE HEADER
C
	IF (MOD(LINES,50).EQ.0) WRITE(DATAOUT,9080) INFILE,LOWTIME,HITIME
	1,ACCOUNTS(J)
9080	FORMAT('1',' TOTALS FOR FILE: ',A,' FOR THE PERIOD ',A,' TO ',A,/
	2	' ACCOUNT NAME:  ',A8,//,
	2	' USERNAME    LOGIN-COUNT  CONNECT TIME'
	2	' CPU-SECONDS',
	2	'  BUF I/O   DIR I/O VOL-MOUNTS  ',
	2	'PRINT-JOBS PRINT PGS')
	WRITE(DATAOUT,9085) USERNAME(I),ICOUNTS(I,3),HRS,MINS,SECS,CPU_SEC,
	2	ICOUNTS(I,5),ICOUNTS(I,6),ICOUNTS(I,7),
	2	ICOUNTS(I,8),ICOUNTS(I,9)
9085	FORMAT(' ',A12,I10,I7,':',I2,':',I2,F12.0,5I10)
	LINES = LINES + 1
	ACCT_DATA(3,J) = ACCT_DATA(3,J)+ICOUNTS(I,3)
	ACCT_DATA(4,J) = ACCT_DATA(4,J)+ICOUNTS(I,4)
	ACCT_DATA(5,J) = ACCT_DATA(5,J)+ICOUNTS(I,5)
	ACCT_DATA(6,J) = ACCT_DATA(6,J)+ICOUNTS(I,6)
	ACCT_DATA(7,J) = ACCT_DATA(7,J)+ICOUNTS(I,7)
	ACCT_DATA(8,J) = ACCT_DATA(8,J)+ICOUNTS(I,8)
	ACCT_DATA(9,J) = ACCT_DATA(9,J)+ICOUNTS(I,9)
	ACCT_DATA(10,J) = ACCT_DATA(10,J)+ICOUNTS(I,1)
	TOT_LOGINS = TOT_LOGINS + ICOUNTS(I,3)
	TOT_ELAPSED= TOT_ELAPSED + ICOUNTS(I,4)
	TOT_SECS = TOT_SECS + ICOUNTS(I,1)
	TOT_PJOBS =  TOT_PJOBS + ICOUNTS(I,8)
	TOT_PAGES = TOT_PAGES + ICOUNTS(I,9)
	K = K-1
	IF (K.NE.0) GOTO 9050
9500	CONTINUE
C
C DONE
C
9900	CONTINUE
	WRITE(DATAOUT,9600) INFILE,LOWTIME,HITIME
9600	FORMAT('1TOTALS FOR FILE:  ',A,' FOR THE PERIOD ',A,' TO ',A,/
	1	' SUMMARY PAGE',//,
	1	' ACCOUNT   USERS  LOGINS   CONNECT TIME',
	1	' CPU-SECONDS  BUF I/O   DIR I/O VOL-MOUNTS  ',
	1	'PRINT-JOBS PRINT-PGS',//)
C
C	OUTPUT ACCOUNT TOTALS
C
	DO 9605 J = 1,MAX_ACCT_PARMS
9605	ACCT_DATA(J,0) = 0
C
	DO 9620 I = 1,NUMBERACCT
	CALL SECS_CVT(ACCT_DATA(4,I),HRS,MINS,SECS)
	CPU_SEC = FLOAT(ACCT_DATA(10,I))/100.0
	WRITE(DATAOUT,9610) ACCOUNTS(I),ACCT_DATA(2,I),ACCT_DATA(3,I),
	1HRS,MINS,SECS,CPU_SEC,ACCT_DATA(5,I),ACCT_DATA(6,I),
	2ACCT_DATA(7,I),ACCT_DATA(8,I),ACCT_DATA(9,I)
9610	FORMAT(' ',A8,I6,I10,I7,':',I2,':',I2,F12.0,5I10)
	DO 9620 J = 1,10
	ACCT_DATA(J,0) = ACCT_DATA(J,0)+ACCT_DATA(J,I)
9620	CONTINUE
C
	CALL SECS_CVT(ACCT_DATA(4,0),HRS,MINS,SECS)
	CPU_SEC = FLOAT(ACCT_DATA(10,0))/100.0
	WRITE(DATAOUT,9630)
9630	FORMAT(/,' SYSTEM')
	WRITE(DATAOUT,9610) 'TOTAL   ',ACCT_DATA(2,0),ACCT_DATA(3,0),
	1HRS,MINS,SECS,CPU_SEC,ACCT_DATA(5,0),ACCT_DATA(6,0),
	2ACCT_DATA(7,0),ACCT_DATA(8,0),ACCT_DATA(9,0)
C2
C2	Useful Data dump is here
C2
	CALL SUBQUAD(LAST_TIME,FIRST_TIME,ELAPSED)
	CALL EDIV(ELAPSED,10000000,IELAPSE)
	MONTHTIME = IELAPSE
	MONTHHRS = IELAPSE/(60.0*60.0)
	WRITE(DATAOUT,9710) FLOAT(ACCT_DATA(9,0))/3200,
	1 FLOAT(ACCT_DATA(10,0))/MONTHTIME, FLOAT(HRS)/MONTHHRS
9710	FORMAT(' Boxes of paper = ',F6.2,/,' CPU Utilization = ',F5.2,
	1 /,' Average Number of Jobs = ',F5.2)
	WRITE(DATAOUT,9910) TOTAL_RECORDS
9910	FORMAT(/' TOTAL RECORDS READ  = ',I10)
	WRITE(DATAOUT,9920) LOGIN_FAIL_CNT
9920	FORMAT(' LOGIN FAILURE COUNT = ',I10)
C
C CONVERT FIRST TIME AND LAST TIME TO ASCII
C
9928	CALL CVT_TIME(TIMBUF1,LEN1,FIRST_TIME)
	CALL CVT_TIME(TIMBUF2,LEN2,LAST_TIME)
	WRITE(DATAOUT,9930) TIMBUF1,TIMBUF2
9930	FORMAT('0THIS DATA IS FROM ',A,' TO ',A)
	TYPE 9940
9940	FORMAT(' **** DONE ****')
	CALL EXIT
C
C ERROR ON INPUT
C
9950	TYPE 9960
9960	FORMAT(////' **** ERROR ON INPUT ****'////)
	GO TO 100
C
C ERROR ON OUTPUT
C
9970	TYPE 9980
9980	FORMAT(////' **** ERROR ON OUTPUT ****'////)
	GO TO 100
	END
C
C **********************************************
C
C SUBROUTINE TO UPDATE THE TIME SPAN OF THE FILE
C
C **********************************************
C
	FUNCTION CHECK_TIME(CURRENT)
	IMPLICIT INTEGER(A-Z)
	COMMON FIRST_TIME(2),LAST_TIME(2),FILE_TYPE,DATAOUT,
	2	LOW_TIME(2),HI_TIME(2)
	DIMENSION CURRENT(2),TEMP(2)
C
C	TEST FOR RECORD WITHIN SPECIFIED RANGE
C
	CALL SUBQUAD(CURRENT(1),LOW_TIME(1),TEMP(1))
	IF(TEMP(2) .GE. 0) GO TO 4
	CHECK_TIME = .FALSE.	!OUT OF RANGE
	RETURN
4	CALL SUBQUAD(HI_TIME(1),CURRENT(1),TEMP(1))
	IF (TEMP(2) .GE. 0) GO TO 8
	CHECK_TIME = .FALSE.	!OUT OF RANGE
	RETURN
C
C	CHECK IF THIS IS NEW FIRST TIME VALUE
C
8	CALL SUBQUAD(CURRENT(1),FIRST_TIME(1),TEMP(1))
	IF (TEMP(2) .GE. 0) GO TO 10
	FIRST_TIME(1)=CURRENT(1)
	FIRST_TIME(2)=CURRENT(2)
10	CALL SUBQUAD(CURRENT(1),LAST_TIME(1),TEMP(1))
	IF (TEMP(2) .LT. 0) GO TO 20
	LAST_TIME(1)=CURRENT(1)
	LAST_TIME(2)=CURRENT(2)
20	CHECK_TIME = .TRUE.
	RETURN
	END
C
C *************************************
C
C SUBROUTINE TO CONVERT A TIME TO ASCII
C
C *************************************
C
	SUBROUTINE CVT_TIME(TIMEBUFFER,LENGTH,TIME)
	IMPLICIT INTEGER(A-Z)
	COMMON FIRST_TIME(2),LAST_TIME(2),FILE_TYPE,DATAOUT
	CHARACTER*24 TIMEBUFFER
	DIMENSION TIME(2)
	STATUS=SYS$ASCTIM(LENGTH,TIMEBUFFER,TIME,%VAL(0))
	IF(.NOT.STATUS) TYPE 10,STATUS
10	FORMAT(' *** ASCTIM FAILED, STATUS = ',Z8)
	RETURN
	END
	SUBROUTINE SECS_CVT(TIME,HRS,MINS,SECS)
	IMPLICIT INTEGER(A-Z)
	SECS = TIME
	HRS = SECS/3600
	MINS = (SECS - HRS*3600) / 60
	SECS = SECS - (HRS*3600) - (MINS*60)
	RETURN
	END
