C *****************************************************************************
C *	   Infinite-User, Variable-Server Queue Simulation Program            *
C *				by					      *
C *			   Kenneth Scott				      *
C *			       and					      *
C *			   Douglas Ford					      *
C *			Oak Industries Inc.				      *
C *		    Advanced Technology Group				      *
C *			     9/1/81					      *
C *****************************************************************************
C
C
C 	THIS PROGRAM, WHEN LINKED WITH THE OBJECT LIBRARIES "INQUSIMUL.OLB" &
C 	"PLTUSL.OLB", WILL BECOME A SYSTEM THAT MODELS THE WAY A QUEUEING 
C 	SYSTEM OF AN INFINITE AMOUNT OF USERS WILL BEHAVE.  IT WILL CALCULATE 
C 	INDIVIDUAL VALUES AS WELL AS PLOT GRAPHS.
C	
C	ALL DOCUMENTATION ON SUBROUTINES IS CONTAINED IN THE [SCOTT.FOR.QUEUE]
C 	DIRECTORY.
C
C	THERE IS A PROBLEM WITH THE GRAPHICS PORTION, AS CERTAIN VALUES ARE TOO
C 	PRECISE FOR THE PROGRAM TO HANDLE.  IT HAS PROBLEMS WITH HIGH AMOUNTS
C 	OF SERVERS, AS THAT MAKES THE PROBABILITIES GO DOWN EXPONENTIALLY.
C	
C
	REAL MEANTI,NINPER,TOTMEN 
	INCLUDE 'COMMON.FOR'
	TYPE *,'WELCOME TO THE QUEUE SIMULATION PROGRAM'
998	TYPE *,
	TYPE *,
	TYPE *,' PLEASE ENTER THE TRAFFIC INTENSITY'
	TYPE *,' (TRAFFIC INTENSITY IS RATIO OF TIME USED BY USERS/TIME AVAIL-'
	TYPE *,' ABLE)'
	READ *,U
	TYPE *,
	TYPE *,
	TYPE *,' PLEASE ENTER THE NUMBER OF SERVERS ON THE SYSTEM'
	READ *,C
	TYPE *,
	TYPE *,
2	TYPE *,'PLEASE ENTER THE EXPECTED (AVERAGE OR MEAN) SERVICE TIME'
	TYPE *,'FOR ONE CUSTOMER'
	TYPE *,'IF YOU DO NOT KNOW THIS VALUE BUT HAVE SOME DATA, INPUT A NEG-'
	TYPE *,'ATIVE VALUE. '
	READ *,EXPSERTIM
	TYPE *,
	TYPE *,
	IF(EXPSERTIM.LT.0.0) EXPSERTIM=EXSRTM()

999	CALL LIST
	READ *,K
	TYPE *,
	GOTO (1,3,4,7,8,5,6,10,998,145,800),K	
1	B=ERLANG()
	TYPE *,'THE PROBABILITY THAT AN ARRIVING CUSTOMER MUST WAIT = ',B
	GOTO 999
3	B=MEANTI()
	TYPE *,'THE MEAN QUEUEING TIME IN THE SYSTEM = ',B
	GOTO 999
4	B=TOTMEN()
	TYPE *,'THE MEAN TIME IN THE SYSTEM = ',B
	GOTO 999
5	B=NINPER()
	TYPE *,'THE 90th PERCENTILE TIME IN THE QUEUE = ',B
	GOTO 999
6	B=ARRVAL()
	TYPE *,'THE MEAN INTERARRIVAL TIME OF CUSTOMERS = ',B
	GO TO 999
7	B=AVCSQU()
	TYPE *,'THE AVERAGE NUMBER OF CUSTOMERS IN THE QUEUE =',B
	GO TO 999
8	B=AVCSTO()
	TYPE *,'THE AVERAGE NUMBER OF CUSTOMERS BOTH IN QUEUE AND SERVED=',B
	GO TO 999
10	CALL HELP
	GO TO 999

145	CALL VARLIS
	READ *,M
	GOTO(210,220,230,240),M
210	CONTINUE
	CALL FUNLI1
	CALL UGRAPH
	GO TO 999
	
220	CONTINUE
	CALL FUNLI2
	CALL CGRAPH
	GO TO 999

230	CONTINUE
	CALL FUNLI3
	CALL MTIGRA
	GO TO 999

240	CONTINUE
	CALL FUNLI4
	CALL MTOGRA
	GO TO 999

800	CONTINUE
	CALL EXIT
	END

C******************************************************************************
