C Fortran subroutine to modify the process p1 vasriable ctl$t_account
C this is used to change the account field in all the accounting manager
C records to a charge number. 

	Subroutine modaccnt(charge)

	implicit integer (a-z)

	parameter (clen=12)			!charge number length

	integer*2 rbcnt

	byte charge(clen),bcharge(clen),rcharge(8)

	external  mod_km,ctl$t_account

	data rbcnt/clen/

	common /mod_km/ rcharge



C Convert the charge to nnnn.nnn.nn vs nnnn-nnn-nn

	
	do i=1,clen

	bcharge(i)=charge(i)
	if (bcharge(i).eq.'_')bcharge(i)='.'	!change from - to .

	end do

C Convert the charge to rad50

	call irad50(rbcnt,bcharge,rcharge)	!Don't believe I'm using rad50

C Change to kernal mode and modify account field

	mod_km_adr=%loc(mod_km)			!set addr for kernal mode code
	call iferr(sys$cmkrnl(%val(mod_km_adr),))

C debug code	

D	ctl$t_account_adr=%loc(ctl$t_account)
D	call r50asc(rbcnt,%val(ctl$t_account_adr),bcharge)
D	type 1000,bcharge
D1000	format(x,'p1account=',12a1)

	end


	Subroutine mod_km

	implicit integer (a-z)

	
	byte rcharge(8)

	common /mod_km/ rcharge

	external ctl$t_account

	ctl$t_account_adr=%loc(ctl$t_account)	!set addr of p1 sym
	call store(rcharge,%val(8),%val(ctl$t_account_adr)) !store rad50 value
	return
	end

