/*
 *==================================================
 * JPL C I/O runtime system
 * routines to handle buffered I/O (Originally written by Julian Gomez)
 *==================================================
 */
#include <stdio.h>
#include "[levy.c]eric.h"
#define FALSE 0
#define TRUE  0
#define REGIST

static char     *jablist[5] = 0;
jab      *_jabhead = NULL;
int	errno = 1;

function FILE *fopen(name,access,_class) char *name,*access,*_class;
	{
	REGIST int i;
	REGIST jab *j;
        char *class;
	static int inited = FALSE;

	if(nargs() < 3) then
           class = "r";
        els
           class = _class;
        fi
	if (!inited) then
		_jabhead = ilist(jablist);
		inited = TRUE;
	fi
	j = _grab(sizeof(jab),class);
	_stab(j,access,name,class);
	i = _open(j,access,class);
	if (VMSerr(i)) then
		errno = i;
		_close(j);
		return(NULL);
	fi
	j->j_ptr	= j->j_buf;
	j->j_chan	= 0;
	j->j_seek       = 0;
	j->j_peek       = -1;
	j->j_status	= 0;
	j->j_access     = ((access[0]=='w') || (access[0]=='W') ||
			   (access[0]=='u') || (access[0]=='U') ||
			   (access[0]=='a') || (access[0]=='A'))? 'w' : 'r';
	j->j_class      = ((class[0]=='r') || (class[0]=='R')) ? 'r' : 'u';
	j->j_count      = (j->j_access == 'w') ? BUFSIZE : 0;

	if (j->j_class  == 'u') then
	    j->j_dirty =  -1;   /* indicate needs to be read in */
	    lseek(j,0,0);       /* and do the first seek */
	fi

        insert(_jabhead,j);
	return(j);
	}

function fclose(stream) REGIST FILE *stream;
{
	REGIST int i;

	if (stream->j_class == 'u') then
		_flushr(stream);
	els
	   if ((stream->j_access == 'w') && (stream->j_count < BUFSIZE)) then
		if (stream->j_class == 'r') then
		    _flushb(stream,NL);
		fi
	   fi
	fi

	i = _close(stream);
	if (VMSerr(i)) then
		errno = i;
	fi
	release(delete(stream));
	}

function ferror()
{
	return(errno);
	}

function fflush(stream) FILE *stream;
{

	if (stream->j_class == 'r') then
	     return(_flushb(stream,NL));
	fi
}

function fputc(c,ioptr) char c; FILE *ioptr;
{
	putc(c,ioptr);
}

function fgetc(ioptr) FILE *ioptr;
{
	return(getc(ioptr));
}
