/*
 *==================================================
 * JPL C I/O runtime system
 * routines to handle buffered I/O
 *==================================================
 */
#include <stdio.h>
#include "jeg.h"

static char     *jablist[5] = 0;
jab      *_jabhead = NULL;
int	errno = 1;

FILE *fopen(name,access,class)
	char *name,*access;
	begin
	register int i;
	register jab *j;
	static logical inited = FALSE;

	if (not inited) {
		_jabhead = ilist(jablist);
		inited = TRUE;
		fi
	j = _grab(sizeof(jab));
	_stab(j,access,name);
	i = _open(j,access);
	if (VMSerr(i)) {
		errno = i;
		_close(j);
		return(NULL);
		fi
	j->j_ptr	= j->j_buf;
	j->j_chan	= 0;
	j->j_peek       =-1;
	j->j_status	= 0;
	j->j_access     = ((access[0]=='w') || (access[0]=='W'))? 'w' : 'r';
	j->j_count      = (j->j_access == 'w') ? BUFSIZE : 0;
	insert(_jabhead,j);
	return(j);
	end

fclose(stream)
	register FILE *stream;
	begin
	register int i;

	if ((stream->j_access == 'w') && (stream->j_count < BUFSIZE))
		_flushb(stream,NL);
	i = _close(stream);
	if (VMSerr(i))
		errno = i;
	release(delete(stream));
	end

ferror() begin
	return(errno);
	end

fflush(stream)
	FILE *stream;
	begin
	return(_flushb(stream,NL));
	end

fputc(c,ioptr)
	char c;
	FILE *ioptr;
	begin
	putc(c,ioptr);
	end

fgetc(ioptr)
	FILE *ioptr;
	begin
	return(getc(ioptr));
	end
