%{
#define txt yytext
#define ECHOCHAR putchar(yytext[0])
#define NEWLINE printf("\n");
#define NEWLINE
#include "[levy.c]eric.h"
extern FILE *yyin,*stdin,*yyout,*stdout;
int argc_ = 0;  int level=0;
char *argv_[20] = 0;
FILE *files[100] = 0;
int body =0;
%}
%Start NORMAL
%a5000
D      ([0-9])
L      ([a-zA-Z])
ALPHA   ({D}|{L})
NUMBER  ({D}+)
LABEL   ({L}{ALPHA}*)
WHITE   ((" "|"\t")*)
WHITEP  ((" "|"\t")+)
SCALAR  ({L}({L}|{D}|"."|"_"|"$")*)
NSCALAR  ({L}|{D}|"."|"_"|"$")
OPER    ([*+\-/])
REGISTER    ("("[Rr]({D}{1,2})")")
SREGISTER (("("[aA][pP]")")|("("[sS][pP]")")|("("[pP][cC]")")|("("[fF][pP]")"))
AREG        ({REGISTER}|{SREGISTER})
NL          (\n)
EXT         ({ALPHA}*)
NAME        ({ALPHA}+)
DIRECTORY   (("[".*"]")|({NAME}":"))
DOT         (".")
FILESPEC    ({DIRECTORY}?{NAME}({DOT}{EXT})?)
Q       \"
LQ       ("`"|"'")
TOUGH   ("["|" "|","|">"|"<"|"]")
ESCAPENL (\\"n")
ESCAPETAB (\\"t")
%%
^"~".*$          {ECHO; }
^"%".*$          { printf("%s",&txt[1]); }
{LQ}{TOUGH}{LQ}   {
		  printf("#%d",txt[1]);
		}
{LQ}{ESCAPENL}{LQ}   {
		  printf("#10");
		}
{LQ}{ESCAPETAB}{LQ}   {
		       printf("#9");
				}
{LQ}.{LQ}               {ECHO; }   /*  Rest of `.' stuff              */
{Q}[^"\n]*{Q}   {ECHO; }           /* don't look at quoted strings    */
<NORMAL>{WHITEP}  {printf(" ");}   /* delete all leading whitespace   */
<NORMAL>^{WHITE}";".*{NL} {printf("\n");}  /* delete all comments to nl  */
^{WHITE}{NL}      {printf("\n"); } /* all blank lines, just a nl      */
\\{NL}          {printf(" ");}     /* continuation lines 1 space      */
" \\ "          {printf("%n"); }   /* treat \  as on the line nl      */
"#""<"?"-"?({NSCALAR}+)({OPER}{NSCALAR}+)*">"?  |  /* copy out immed exprs */
"-"?({NSCALAR}+)({OPER}{NSCALAR}+)*{AREG}       | /* copy displacement stuff */
[eE][nN][dD]-                                   |
({AREG}"+")|("-"{AREG})                     { ECHO; }
{SCALAR}"++"    {
			int i; i = strlen(txt); txt[i-2] = '\0';
			printf("%s := %s + 1",txt,txt);
                }
{SCALAR}"--"    {
			int i; i = strlen(txt); txt[i-2] = '\0';
			printf("%s := %s - 1",txt,txt);
                }
"--"{NUMBER}    { printf(" %s",&txt[1]); }       /* --123 becomes -123 */
"{"             {ECHO; body = 1; }
"}"             {ECHO; body = 0; }
":="           |
"+"            |
"-"            |
"/"            |
"*"            {
		if (body == 1) then
		   printf(" %s ",txt);
                els
                   ECHO;
                fi
		}
">="            {printf(" ge "); }
"<="            {printf(" le "); }
"!="            {printf(" ne "); }
"=="            {printf(" eq "); }
" > "           {printf(" gt "); }
" < "           {printf(" lt "); }
"||"            {printf(" or "); }
"&&"            {printf(" and "); }
^{WHITE}include{WHITEP}{FILESPEC}{WHITE}{NL} {
					 /* include files, just stack yyin */
				int j,i; i=pos(txt,"e",1);
				files[level] = yyin;
				level++;
				j=strlen(txt); txt[j-1] = '\0';
				yyin = fopen(&txt[i+1],"read","r");
				if (yyin == NULL) then
				   exit(1);
				fi
				}
{AREG}                  { ECHO; }
"("                     { putchar('<'); }
")"                     { putchar('>'); }
.|{NL}                  { ECHOCHAR; }
%%
main (argc,argv )  int argc; char *argv[];
{
int i;
level = 0;
for (i=0; i<argc ; i++)
   {
     argv_[i] = argv[i];
   }
	if(argc > 1) then
	   stolower(argv[1]);
	fi
	if (argc > 1 && eq(argv[1],"-k",2) != 0) then
	   BEGIN 0;
	els
	   BEGIN NORMAL;
	fi

	argc_ = argc;
	yyin = stdin;
	yyout = stdout;
    for (;;) {
	yylex();
	if (level > 0) then
	   yyin = files[--level];
	els
	   exit(1);
	fi
    rof
}
yywrap (){ return(1);}
