C	Start of include file DMPCOM.FOR
C
C	Common block for DUMPER program
C
C	DMPCOM holds the integer and logical common variables
C	SIGN    -- Sign of value (if any)
C	SKIPNO  -- Number of save sets to skip
C	DONE    -- If .TRUE., leave the program
C	GOVALUE -- Number of save sets to process
C	CHANNEL -- Channel number of the magtape
C	DEVLEN  -- Length of the device name
C	GOTDEV  -- If .TRUE., a device has been assigned
C	BLKTYP -- The type of data block on the tape.  It can have
C	the values NONE, STDBLK, and CCCBLK for undefined, standard,
C	and CCC stupid TU70 format.
C	EOFSEEN -- Flag indicating if the previous operation
C	caused the end of file to be found
C	FILEOK  -- Flag indicating if an output file is open
C	and that the data is to be copied to the output file.
C	IOMODE -- This indicates the type of input conversion
C	that is to be done.  If equal to BINARY, the data is
C	copied to the output without conversion into 5 bytes
C	per DEC 10/20 word.  If equal to ASCII, the data is
C	copied to the output with 7 bit bytes converted to
C	8 bit bytes.
C	PRMODE -- Printing mode flag.  If equal to SILENT, then
C	no file names are echoed on the terminal.  If equal to
C	FILES, then the file names are printed on the terminal
C	as they are copied.
C	ORMODE -- Output Record Mode.  If equal to NONE, then
C	no carriage control attributes are set on the output
C	file.  If equal to CR, then the Carriage Return attribute
C	is set for the output file.  If equal to FORTRAN, then
C	the FORTRAN attribute is set for the output file.
C	LIST   -- Listing flag.  If .TRUE., then a file is opened
C	on channel 2 to recieve the listing of the file data.
C	TERCHAN -- Terminal channel for Control-C AST processing.
C	ABFLAG  -- Is .TRUE. if aborted due to Control-C input
C	by the user.  Is .FALSE. otherwise.
C
	INTEGER*4 SIGN,SKIPNO
	LOGICAL*4 DONE,GOTDEV
	INTEGER*4 GOVALUE,CHANNEL
	INTEGER*4 DEVLEN
	INTEGER*2 BLKTYP,NONE,STDBLK,CCCBLK
	PARAMETER (NONE=0,STDBLK=1,CCCBLK=2)
	LOGICAL*4 EOFSEEN
	LOGICAL*4 FILEOK
	INTEGER*2 IOMODE,BINARY,ASCII
	PARAMETER (ASCII=0,BINARY=1)
	INTEGER*2 PRMODE,SILENT,FILES
	PARAMETER (SILENT=0,FILES=1)
	INTEGER*2 ORMODE,CR,FORTRAN
	PARAMETER (CR=1,FORTRAN=2)
	LOGICAL*4 LIST
	INTEGER*4 TERCHAN
	LOGICAL*4 ABFLAG
C
	COMMON /DMPCOM/SIGN,SKIPNO,DONE,GOVALUE,CHANNEL,
	1 DEVLEN,GOTDEV,BLKTYP,EOFSEEN,FILEOK,IOMODE,
	2 PRMODE,ORMODE,LIST,TERCHAN,ABFLAG
C
C	DMPCHR common holds the character variables for dumper
C	DEVNAME -- Name of the magtape device
C
	CHARACTER*64 DEVNAME
	COMMON /DMPCHR/DEVNAME
C
C	End of include file DMPCOM.FOR
