	program accsplit
c
c	this program will chop up the accounting file into
c	smaller 'monthly' chunks that are a lot easier to
c	use and move around.
c
	integer*2 msgtyp,msgsiz
	integer*4 finalsts,pid,jobid,termtime(2)
	character*8 account
	character*12 username
	character*120 rest
	integer*2 restlen
c
	character*11 termdate,lastdate
	character*64 ifile,ofile
	integer*2 ifilel,ofilel
	parameter iunit=1
	parameter ounit=2
c
	type 10
10	format(' ACCSPLIT -- program to split the accounting file',/,
	1 ' Version 1.0')
20	type 30
30	format(' Enter name of accounting file to split:  ',$)
	accept 40,ifilel,ifile
40	format(q,a)
	if (ifilel.eq.0) goto 1000
	open (unit=iunit,name=ifile(1:ifilel),type='old',readonly,
	1 err=20)
c
c	initialize the chopping for this file
c
	read(iunit,50,err=990,end=900) msgtyp,msgsiz,finalsts,pid,
	1 jobid,termtime,account,username,restlen,rest
50	format(2a2,5a4,a8,a12,q,a)
	call sys$asctim(,%descr(lastdate),%ref(termtime),)
	ofile = lastdate(4:6) // lastdate(8:11) // '.DAT'
	ofilel = 11
	type 60,ofile(1:ofilel)
60	format(' Opening ',a,' for output')
	open(unit=ounit,name=ofile(1:ofilel),type='new',err=980,
	1 carriagecontrol='none')
	write(ounit,70,err=990) msgtyp,msgsiz,finalsts,pid,
	1 jobid,termtime,account,username,rest(1:restlen)
70	format(2a2,5a4,a8,a12,a)
c
c	main loop...
c
100	continue
	read(iunit,50,err=990,end=900) msgtyp,msgsiz,finalsts,pid,
	1 jobid,termtime,account,username,restlen,rest
	call sys$asctim(,%descr(termdate),%ref(termtime),)
	if (termdate(4:11).eq.lastdate(4:11)) then
	 write(ounit,70,err=990) msgtyp,msgsiz,finalsts,pid,
	1 jobid,termtime,account,username,rest(1:restlen)
	else
	 close(unit=ounit)
	 lastdate = termdate
	 ofile = lastdate(4:6) // lastdate(8:11) // '.DAT'
	 type 60,ofile(1:ofilel)
	 open(unit=ounit,name=ofile(1:ofilel),type='new',err=980,
	1 carriagecontrol='none')
	 write(ounit,70,err=990) msgtyp,msgsiz,finalsts,pid,
	1 jobid,termtime,account,username,rest(1:restlen)
	endif
	goto 100
c
c	end of input file...
c
900	continue
	close(unit=iunit)
	goto 20
c
c	error in opening output file
c
980	continue
	type 985,ofile(1:ofilel)
985	format(' Cannot open output file')
	stop 'abort'
c
c	error in copying a record
c
990	continue
	type 995
995	format(' Error copying a record')
	stop 'abort'
c
c	normal exit
c
1000	continue
	stop 'Done'
	end
