$V='F$VERIFY(0)'
$SET MESSAGE/NOFACIL/NOSEVER/NOIDENT
$!  Command file to backup a single disk to magtape
$!  using the BACKUP program.
$!  P1 -- Name of tape & log file
$!  P2 -- Device of disk to save
$!
$SET NOON
$SETNAME := $SYS:SETNAME
$SETNAME BACKUP
$DELETE/SYM/GLO/ALL
$SET WORKING_SET/LIMIT=350
$SET PROCESS/PRIO=5
$SET PROC/PRIV=BYPASS
$!
$!  Set up the backup log file
$!
$DELETE USER:[BACKUPS]BK'P1'.DAT.*
$SET ON
$ !
$ !  Now get the magtape drive and initialize the tape.
$ !
$ASSIGN NL: SYS$OUTPUT
$ASSIGN NL: SYS$ERROR
$L:
$ON WARNING THEN $GOTO WAITER
$ALLOCATE MTA0:
$DEASSIGN SYS$OUTPUT
$DEASSIGN SYS$ERROR
$MNT:
$ON ERROR THEN $GOTO BAD
$REQUEST/REPLY/TO=TAPES "Please mount the ''P1' backup tape"
$INITIALIZE MTA0:/DENS=1600/PROT=(s:rwed,g,o,w)/OVER=(ACCE,EXPI) 'P1'
$MOUNT MTA0: 'P1'
$GOTO SAVEIT
$!
$!  Trouble with the tape
$!
$BAD:
$REQUEST "Error with ''P1' tape, please try again"
$GOTO MNT
$ !
$ !  Tape not available, wait for 1 minute then try again
$ !
$WAITER:
$WAIT 00:01
$GOTO L
$ ! 
$ !  Now get ready to skim directories
$ !
$SAVEIT:
$ON ERROR THEN $GOTO CLEAN
$SET NOVERIFY
$REQUEST "On relative volume mounts, reply message = ''P1'/BLANK"
$BACKUP/RECORD 'P2':[000000] MTA0:000000.BKP
$@USER:[OPERATOR]DISKBK/OUT=USER:[BACKUPS]BK'P1'.DAT 'P2'
$!
$!  All done/error, clean up & exit
$!
$CLEAN:
$SET NOON
$SHORT :== $USER:[OPERATOR]SHORTEN
$SHORT USER:[BACKUPS]BK'P1'.DAT
$PURGE USER:[BACKUPS]BK'P1'.DAT
$IF V THEN $SET VERIFY
$IF "''F$MODE()'".EQS."BATCH" THEN $LOGOUT
$EXIT
