C
C-------SUBROUTINE PRINTO--------------------------OAK INDUSTRIES INC.---------
C
C SUBROUTINE PRINTS OUT THE GRAPH OF THE DATA.
C
	SUBROUTINE PRINTO(NP,N,M)

	INTEGER NP,N,M
	INCLUDE 'COMMONF.FOR'
C
C SUBROUTINE SCALE DETERMINES HOW MANY TIC MARKS GO ON EACH AXIS.
C
	CALL SCALE(RWD,10.,NP,1)
	CALL SCALE(RFRAM,8.,NP,1)
C
C SUBROUTINE PLOTST MAKES THE TIC MARKS EITHER AN INCH OR A CENTIMETER APART.
C
	CALL PLOTST(.002,'IN',1)
C
C SUBROUTINE FACTOR SCALES THE SIZE OF THE PLOT BY THE ARGUMENT GIVEN IT.
C
	CALL FACTOR(0.8)
C
C SUBROUTINE PLOT INITIALIZES THE POSITION OF THE ORIGIN.
C
	CALL PLOT(0.5,0.5,-3)
C
C SUBROUTINE AXIS LABELS THE AXIS.
C
	IF(M.EQ.1) THEN
		CALL AXIS(0.,0.,'MEAN SERVICE TIME',-17,8.,0.,RFRAM(NP+1)
     1		,RFRAM(NP+2))
	ELSE IF(M.EQ.2) THEN
		CALL AXIS(0.,0.,'MEAN THINK TIME',-15,8.,0.,RFRAM(NP+1),
     1		RFRAM(NP+2))
	ELSE IF(M.EQ.3) THEN
		CALL AXIS(0.,0.,'NUMBER OF USERS',-15,8.,0.,RFRAM(NP+1)
     1		,RFRAM(NP+2))
	END IF

	IF(N.EQ.1) THEN
		CALL AXIS(0.,0.,'PROB. CPU IDLE',14,10.,90.,
     1		RWD(NP+1),RWD(NP+2))
	ELSE IF(N.EQ.2) THEN
		CALL AXIS(0.,0.,'CPU UTILIZATION',15,10.,90.,RWD(NP+1),
     1		RWD(NP+2))
	ELSE IF(N.EQ.3) THEN
		CALL AXIS(0.,0.,'MEAN RESPONSE TIME',18,10.,90.,RWD(NP+1),
     1		RWD(NP+2))
	ELSE IF(N.EQ.4) THEN
		CALL AXIS(0.,0.,'THROUGHPUT IN INTERACTS./TIME',29,10.,90.,
     1		RWD(NP+1),RWD(NP+2))
	ELSE IF(N.EQ.5) THEN
		CALL AXIS(0.,0.,'AVERAGE NO. INTERACTIONS PENDING',32,10.,90.,
     1		RWD(NP+1),RWD(NP+2))
	ELSE IF(N.EQ.6) THEN
		CALL AXIS(0.,0.,'SYSTEM SATURATION POINT',23,10.,90.,
     1		RWD(NP+1),RWD(NP+2))
	END IF

	CALL PLOT(0.,0.,-3)
C
C SUBROUTINE LINE CONNECTS ALL THE POINTS ON THE GRAPH.
C
	CALL LINE(RFRAM,RWD,NP,1,0,0)
	CALL PLOT(0.,0.,-3)
C
C SUBROUTINE SYMBOL GIVES A TITLE TO THE GRAPH.
C
	CALL SYMBOL(1.,9.5,0.2,'OAK INDUSTRIES INC.',0.,19)
	CALL SYMBOL(1.,9.,0.2,'ADVANCED TECHNOLOGY GROUP',0.,25)
	CALL SYMBOL(1.,8.5,0.2,'QUEUEING SIMULATION PLOT',0.,24)	
C
C SUBROUTINE PLOTND ENDS THE PLOT.
C
	CALL PLOTND

	TYPE *,
	TYPE *,'IN ORDER TO PRINT OUT THE GRAPH OF THE FUNCTION YOU MUST'
	TYPE *,'THESE STEPS:'
	TYPE *,
	TYPE *,'		1.  $PLXY <CR>'
	TYPE *,'		2.  PLT> <CR>'
	TYPE *,'		3.  PLT>EXIT <CR>'
	TYPE *,'		4.  $PLOT <CR>'
	TYPE *,
	RETURN
	END
C------------------------------------------------------------------------------
