C	NOTE TO SYSTEM MANAGER:
C		COMPILE,LINK AND MOVE TO [SYSEXE] AND GIVE WORLD EXECUTE PRIV.
C		IN SITE DEPENDENT LOGIN.COM ([SYSMGR]SYLOGIN.COM) FILE INSERT
C		$ RUN SYS$SYSTEM:PROCNAME
C******************************************************************************
C
C	VAX PROCESS NAME CHANGER
C
C
C	THIS ROUTINE WORKS WITH INTERACTIVE JOBS AND BATCH JOBS
C	THE PROCESS NAME (FOR INTERACTIVE) BECOMES TT#_USERNAME  E.G. A7_SYSTEM
C	THE PROCESS NAME (FOR BATCH) BECOMES BATCHJOB#USERNAME  E.G. 126OPERATOR
C
C	AUTHOR: UNKNOWN	PARTY AT M.I.T.
C		THIS VERSION BY:	GARY SIFTAR
C					VIKING INFORMATION SYSTEMS
C					2815 E. SKELLY DRIVE  SUITE 816
C		V02.01			TULSA, OK	 74105
C					(918) 745-6500
C
	PROGRAM PROCNAME
C
	PARAMETER	JPI$_USERNAME='202000C'X	! CODE FOR GETJPI
	PARAMETER	JPI$_PRCNAM='31C000C'X		! CODE FOR GETJPI
	INTEGER*4	SYS$GETJPI,	SYS$TRNLOG
	INTEGER*4	ITEMDSCRP(6)			! ITEM LIST FOR GETJPI
	INTEGER*2	USRNAM_L,	PRCNAM_L
	CHARACTER*12	TTNUM				! BUFFER FOR TT STRING
	CHARACTER*12	USERNAME			! USER NAME BUFFER
	CHARACTER*12	PRCNAM				! OLD PROCESS NAME BUFF
	CHARACTER*15	NEWPRCNAM			! NEW PROCESS NAME BUFF
C
C
C	INITIALIZE ITEMLIST... NEED USERNAME AND PROCESS NAME
C
	ITEMDSCRP(1) = JPI$_USERNAME
	ITEMDSCRP(2)=%LOC(USERNAME)
	ITEMDSCRP(3)=%LOC(USRNAM_L)
	ITEMDSCRP(4)= JPI$_PRCNAM
	ITEMDSCRP(5)=%LOC(PRCNAM)
	ITEMDSCRP(6)=%LOC(PRCNAM_L)
C
C	GET USERNAME AND PROCESS NAME
C
	CALL SYS$GETJPI(,,,ITEMDSCRP,,,)
C
C	TRANSLATE TT TO GET TERMINAL NUMBER
C
	CALL SYS$TRNLOG('TT',ILEN,TTNUM,,%VAL(3),,)
C
C	CREATE THE NEW PROCESS NAME AND CALL 'SET PROCESS NAME'
C		MOVE FIRST THREE CHARACTERS
	IF(PRCNAM(1:4).EQ.'_JOB')THEN			! BATCH GETS JOB #
		NEWPRCNAM(1:3)=PRCNAM(5:7)
	   ELSE						! INTERACTIVE GETS TT#
		NEWPRCNAM(1:2) = TTNUM(4:5)
		IF(TTNUM(2:3).EQ.'OP')NEWPRCNAM(1:2)='OP' ! OPERATOR CONSOLE=OP
		NEWPRCNAM(3:3) = '_'
	   END IF
C
	NEWPRCNAM(4:4+USRNAM_L) = USERNAME(1:USRNAM_L)	! THEN MOVE IN USERNAME
	DO 10 LENGTH = LEN(NEWPRCNAM),1,-1
	IF(NEWPRCNAM(LENGTH:LENGTH).NE. ' ')GO TO 20  ! FIND LENGTH OF NEW NAME
10	CONTINUE
C
20	CALL SYS$SETPRN(NEWPRCNAM(1:LENGTH))	      ! CHANGE TO THE NEW NAME
C
	END
